/* superviewsupport/superviewsupport.h */
/* Version    : 4.1		       */
/* Date       : 14.06.1994	       */
/* Written by : Andreas R. Kleinert    */

#ifndef SUPERVIEWSUPPORT_SUPERVIEWSUPPORT_H
#define SUPERVIEWSUPPORT_SUPERVIEWSUPPORT_H


/* *************************************************** */
/* *						     * */
/* * Version Defines				     * */
/* *						     * */
/* *************************************************** */

#define SVSUPPORTLIB_VERSION  4


/* *************************************************** */
/* *						     * */
/* * Includes					     * */
/* *						     * */
/* *************************************************** */

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */


/* *************************************************** */
/* *						     * */
/* * Custom Defines				     * */
/* *						     * */
/* *************************************************** */

#ifndef N
#define N NULL	 /* useful */
#endif /* N */


/*  === ControlPads === */

/* see documentation for more and detailed information on ControlPad-Files */

struct SV_ControlPad          /* These ControlPads are supplied as    */
{                             /* single-chained list, where the       */
 UBYTE *svc_EntryName;        /* pointer to the last entry is NULL.   */
 UBYTE *svc_EntryContent;     /* Do not free them by Hand.            */

 APTR   svc_NextEntry;
};


/*  === Handle for SVSUP_DisplayGfxBuffer()                 === */
/* (has to be allocated, initialized and delocated by the User) */

struct SVSUP_DisplayHandle
{
 /* MUST be initialized : */

 ULONG                  Version;      /* currently 4 */

 struct SV_GfxBuffer   *SVGfxBuffer;    
 struct SVD_DriverNode *SVDriverNode;

 /* MAY be initialized : */

 ULONG                  WinIDCMP; /* Window's IDCMP */
 ULONG                  WinFlags; /* Window's Flags */
 ULONG                  ScrType;  /* Screen-Type    */

 /* MUST NOT be initialized (read-only) : */

 struct SVDriverBase   *SVDriverBase;
 APTR                   SVDriverHandle; 

 struct Window         *Window;
 struct Screen         *Screen;

 /* end of version 4 entries */
};

#endif /* SUPERVIEWSUPPORT_SUPERVIEWSUPPORT_H */
